﻿--
-- Specialization for Cutter
--
-- @author  	Manuel Leithner
-- @version 	v1.0
-- @date  		02/11/11
-- @history:	v1.0 - Initial version
--
-- @edit for kemper maizecutter by usxi7sd 10/2014

roll = {};

function roll.prerequisitesPresent(specializations)
    return true;
end;

function roll:load(xmlFile)	
	self.roll = {};
	self.roll.speedScaleTime = 5000;
	self.roll.speed = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.roll#speed"), 11);
	self.roll.rollSpeedBackup = self.rollNodes[1].speed;
	for _, rollNode in pairs(self.rollNodes) do
		rollNode.backup = rollNode.speed;
		rollNode.speed = 0;
	end;		
end;

function roll:delete()
end;
function roll:readStream(streamId, connection)
end;
function roll:writeStream(streamId, connection)
end;
function roll:mouseEvent(posX, posY, isDown, isUp, button)
end;
function roll:keyEvent(unicode, sym, modifier, isDown)
end;

function roll:update(dt)
	Utils.setEmittingState(self.threshingParticleSystems, (self.reelStarted and self.lastCutterAreaBiggerZero));
	
	if self:getIsActive() and self.reelStarted then	
		local percent = math.max(0.85, math.min((self.lastSpeed*3600) / self.roll.speed, 1.5));
	
		for _, rollNode in pairs(self.rollNodes) do
			local rollSpeed = Utils.getMovedLimitedValues({rollNode.speed}, {rollNode.backup * percent}, {0}, 1, self.roll.speedScaleTime, dt, false);
			rollNode.speed = rollSpeed[1];
		end;
	else
		if self.rollNodes[1].speed ~= 0 then
			local percent = math.max(0.85, math.min((self.lastSpeed*3600) / self.roll.speed, 1.5));
		
			for _, rollNode in pairs(self.rollNodes) do
				local rollSpeed = Utils.getMovedLimitedValues({rollNode.speed}, {rollNode.backup * percent}, {0}, 1, self.roll.speedScaleTime*1.5, dt, true);
				rollNode.speed = rollSpeed[1];
				rotate(rollNode.node, -dt*rollNode.speed, 0, 0);
			end;
		end;
	end;	
end;                                                  

function roll:updateTick(dt)		
end;
function roll:draw()	
end;

function roll:onAttach(attacherVehicle)
	self.combine = attacherVehicle;
end;
function roll:onDetach()		
	self.combine = nil;
end; 

function roll:onStartReel()
end;